//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern int FastPeriod   = 12;
extern int SlowPeriod   = 26;
extern int SignalPeriod =  9;
extern int Price        = PRICE_CLOSE;

double buffUp[];
double buffDn[];
double macd[];
double signal[];
double osma[];
double slope[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0, buffUp); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1, buffDn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2, macd); 
   SetIndexBuffer(3, signal); 
   SetIndexBuffer(4, osma); 
   SetIndexBuffer(5, slope); 
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //

   double alpha = 2.0 /(1.0*SignalPeriod);
   for(i=limit; i>=0; i--)
   {
      macd[i]   = iMA(NULL,0,FastPeriod,0,MODE_EMA,Price,i)-iMA(NULL,0,SlowPeriod,0,MODE_EMA,Price,i);
      signal[i] = signal[i+1]+alpha*(macd[i]-signal[i+1]);
      osma[i]   = macd[i]-signal[i];
      buffUp[i] = EMPTY_VALUE;
      buffDn[i] = EMPTY_VALUE;
      slope[i]  = slope[i+1];
         if (osma[i]>osma[i+1]) slope[i]= 1;
         if (osma[i]<osma[i+1]) slope[i]=-1;
         if (slope[i]== 1) buffUp[i] = 1;
         if (slope[i]==-1) buffDn[i] = 1;
   }      
   return(0);
}